/*
 *  Warning: Do not edit this file.
 *  Auto-generated by 'beam_makeops'.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "sys.h"
#include "erl_vm.h"
#include "export.h"
#include "erl_process.h"
#include "bif.h"
#include "erl_atom_table.h"
#include "beam_load.h"

#include "erl_term.h"
#include "erl_map.h"
#include "big.h"
#include "beam_transform_helpers.h"

static int binary_too_big(LoaderState* S, BeamOpArg Size) {
  return Size.type == TAG_o ||
  (Size.type == TAG_u && ((Size.val >> (8*sizeof(Uint)-3)) != 0));;
}

static int compiled_with_otp_20_or_higher(LoaderState* S) {
  return S->otp_20_or_higher;;
}

static int distinct(LoaderState* S, BeamOpArg Reg1, BeamOpArg Reg2) {
  return Reg1.type != Reg2.type || Reg1.val != Reg2.val;;
}

static int fixed_size_values(LoaderState* S, BeamOpArg Size, BeamOpArg* Rest) {
  int i;

  if (Size.val < 2 || Size.val % 2 != 0) {
    return 0;
  }

  for (i = 0; i < Size.val; i += 2) {
    if (Rest[i+1].type != TAG_f) {
      return 0;
    }
    switch (Rest[i].type) {
      case TAG_a:
      case TAG_i:
      case TAG_v:
      break;
      case TAG_q:
      return is_float(beamfile_get_literal(&S->beam, Rest[i].val));
      default:
      return 0;
    }
  }

  return 1;;
}

static int floats_or_bignums(LoaderState* S, BeamOpArg Size, BeamOpArg* Rest) {
  int i;

  if (Size.val < 2 || Size.val % 2 != 0) {
    return 0;
  }

  for (i = 0; i < Size.val; i += 2) {
    if (Rest[i].type != TAG_q) {
      return 0;
    }
    if (Rest[i+1].type != TAG_f) {
      return 0;
    }
  }

  return 1;;
}

static int independent_moves(LoaderState* S, BeamOpArg Src1, BeamOpArg Dst1, BeamOpArg Src2, BeamOpArg Dst2) {
  return (Src1.type != Dst2.type || Src1.val != Dst2.val) &&
  (Src2.type != Dst1.type || Src2.val != Dst1.val) &&
  (Dst1.type != Dst2.type ||Dst1.val != Dst2.val);;
}

static int is_empty_map(LoaderState* S, BeamOpArg Lit) {
  Eterm term;

  if (Lit.type != TAG_q) {
    return 0;
  }

  term = beamfile_get_literal(&S->beam, Lit.val);
  return is_flatmap(term) && flatmap_get_size(flatmap_val(term)) == 0;;
}

static int is_heavy_bif(LoaderState* S, BeamOpArg Bif) {
  BeamFile_ImportEntry *import;
  Export *export;

  if (Bif.type != TAG_u || Bif.val >= S->beam.imports.count) {
    return 0;
  }

  import = &S->beam.imports.entries[Bif.val];
  export = erts_active_export_entry(import->module,
  import->function,
  import->arity);

  if (export->bif_number != -1) {
    return bif_table[export->bif_number].kind == BIF_KIND_HEAVY;
  }

  return 0;;
}

static int is_offset(LoaderState* S, BeamOpArg X, BeamOpArg Y, Uint Offset) {
  return X.type == Y.type && X.val + Offset == Y.val;;
}

static int is_small_map_literal_keys(LoaderState* S, BeamOpArg Size, BeamOpArg* Rest) {
  if (Size.val > MAP_SMALL_MAP_LIMIT) {
    return 0;
  }

  /*
  * Operations with non-literals have always only one key.
  */
  if (Size.val != 2) {
    return 1;
  }

  switch (Rest[0].type) {
    case TAG_a:
    case TAG_i:
    case TAG_n:
    case TAG_q:
    return 1;
    default:
    return 0;
  };
}

static int literal_is_map(LoaderState* S, BeamOpArg Lit) {
  Eterm term;

  ASSERT(Lit.type == TAG_q);
  term = beamfile_get_literal(&S->beam, Lit.val);
  return is_map(term);;
}

static int map_key_sort(LoaderState* S, BeamOpArg Size, BeamOpArg* Rest) {
  return beam_load_map_key_sort(S, Size, Rest);;
}

static int mixed_types(LoaderState* S, BeamOpArg Size, BeamOpArg* Rest) {
  int i;
  Uint type;

  if (Size.val < 2 || Size.val % 2 != 0) {
    return 0;
  }

  type = Rest[0].type;
  for (i = 0; i < Size.val; i += 2) {
    if (Rest[i].type != type) {
      return 1;
    }
  }

  return 0;;
}

static int negation_is_small(LoaderState* S, BeamOpArg Int) {
  /*
  * Check for the rare case of overflow in BeamInstr (UWord) -> Sint.
  * Cast to the correct type before using IS_SSMALL (Sint).
  */
  return Int.type == TAG_i &&
  !(Int.val & ~((((BeamInstr)1) << ((sizeof(Sint)*8)-1))-1)) &&
  IS_SSMALL(-((Sint)Int.val));;
}

static int never(LoaderState* S) {
  return 0;;
}

static int smp_already_locked(LoaderState* S, BeamOpArg L) {
  ASSERT(L.type == TAG_u);
  return S->labels[L.val].looprec_targeted;;
}

static int smp_mark_target_label(LoaderState* S, BeamOpArg L) {
  ASSERT(L.type == TAG_f);
  S->labels[L.val].looprec_targeted = 1;
  return 1;;
}

static int succ(LoaderState* S, BeamOpArg X, BeamOpArg Y) {
  return X.type == Y.type && X.val + 1 == Y.val;;
}

static int succ3(LoaderState* S, BeamOpArg X, BeamOpArg Y) {
  return X.type == Y.type && X.val + 3 == Y.val;;
}

static int succ4(LoaderState* S, BeamOpArg X, BeamOpArg Y) {
  return X.type == Y.type && X.val + 4 == Y.val;;
}

static int use_jump_tab(LoaderState* S, BeamOpArg Size, BeamOpArg* Rest, Uint MinSize) {
  Sint min, max;
  Sint i;

  if (Size.val < 2 * MinSize || Size.val % 2 != 0) {
    return 0;
  }

  if (Rest[0].type != TAG_i || Rest[1].type != TAG_f) {
    /* Atoms. Can't use a jump table. */
    return 0;
  }

  min = max = Rest[0].val;
  for (i = 2; i < Size.val; i += 2) {
    if (Rest[i].type != TAG_i || Rest[i+1].type != TAG_f) {
      return 0;
    }
    if (Rest[i].val < min) {
      min = Rest[i].val;
    } else if (max < Rest[i].val) {
      max = Rest[i].val;
    }
  }

  return max - min <= Size.val;;
}

int erts_beam_eval_predicate(unsigned int op, LoaderState* st, BeamOpArg var[], BeamOpArg* rest_args) {
  switch (op) {
    case 0: return never(st);
    case 1: return succ(st, var[0], var[1]);
    case 2: return succ(st, var[1], var[2]);
    case 3: return succ3(st, var[0], var[1]);
    case 4: return succ4(st, var[0], var[1]);
    case 5: return use_jump_tab(st, var[2], rest_args, 2);
    case 6: return mixed_types(st, var[3], rest_args);
    case 7: return mixed_types(st, var[2], rest_args);
    case 8: return fixed_size_values(st, var[2], rest_args);
    case 9: return floats_or_bignums(st, var[2], rest_args);
    case 10: return succ(st, var[1], var[3]);
    case 11: return is_offset(st, var[2], var[4], 2);
    case 12: return is_offset(st, var[3], var[5], 3);
    case 13: return is_offset(st, var[4], var[6], 4);
    case 14: return succ(st, var[0], var[2]);
    case 15: return succ(st, var[1], var[4]);
    case 16: return succ(st, var[4], var[6]);
    case 17: return succ(st, var[1], var[5]);
    case 18: return distinct(st, var[1], var[2]);
    case 19: return independent_moves(st, var[0], var[1], var[2], var[3]);
    case 20: return independent_moves(st, var[2], var[3], var[0], var[1]);
    case 21: return smp_mark_target_label(st, var[0]);
    case 22: return smp_already_locked(st, var[0]);
    case 23: return succ(st, var[3], var[5]);
    case 24: return succ(st, var[2], var[4]);
    case 25: return distinct(st, var[2], var[0]);
    case 26: return distinct(st, var[4], var[0]);
    case 27: return is_heavy_bif(st, var[0]);
    case 28: return is_heavy_bif(st, var[1]);
    case 29: return binary_too_big(st, var[1]);
    case 30: return compiled_with_otp_20_or_higher(st);
    case 31: return literal_is_map(st, var[0]);
    case 32: return map_key_sort(st, var[3], rest_args);
    case 33: return map_key_sort(st, var[4], rest_args);
    case 34: return is_empty_map(st, var[0]);
    case 35: return is_small_map_literal_keys(st, var[2], rest_args);
    case 36: return literal_is_map(st, var[1]);
    case 37: return map_key_sort(st, var[2], rest_args);
    case 38: return negation_is_small(st, var[2]);
    case 39: return negation_is_small(st, var[3]);
    default: erts_exit(ERTS_ABORT_EXIT, "erts_beam_eval_predicate: invalid op %d\n", op);  }
}

static BeamOp* allocate(LoaderState* S, BeamOpArg Ns, BeamOpArg Live, BeamOpArg N, BeamOpArg* Yregs) {
  BeamOp* alloc;
  BeamOp** p;

  alloc = beamopallocator_new_op(&(S)->op_allocator);
  alloc->next = NULL;;
  alloc->a[0] = Ns;
  alloc->a[1] = Live;

  if (Ns.val <= 2 * N.val) {
    /*
    * At least half of the Y registers need explicit
    * initialization. It will be cheaper to zero all Y registers.
    */
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      alloc->op = __make_opname__(allocate_zero, 2);
      alloc->arity = 2;
#undef __make_opname__
    } while (0);
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      alloc->op = __make_opname__(allocate, 2);
      alloc->arity = 2;
#undef __make_opname__
    } while (0);
    p = &alloc->next;
    do {
      int i;
      for (i = 0; i < N.val; i++) {
        BeamOp* init;

        init = beamopallocator_new_op(&(S)->op_allocator);
        init->next = NULL;;
        do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
          init->op = __make_opname__(init, 1);
          init->arity = 1;
#undef __make_opname__
        } while (0);
        init->a[0] = Yregs[i];
        *p = init;
        p = &init->next;
      }
    } while (0);
  }
  return alloc;;
}

static BeamOp* allocate_heap(LoaderState* S, BeamOpArg Ns, BeamOpArg Nh, BeamOpArg Live, BeamOpArg N, BeamOpArg* Yregs) {
  BeamOp* alloc;
  BeamOp** p;

  alloc = beamopallocator_new_op(&(S)->op_allocator);
  alloc->next = NULL;;
  alloc->a[0] = Ns;
  alloc->a[1] = Nh;
  alloc->a[2] = Live;

  if (Ns.val <= 2 * N.val) {
    /*
    * At least half of the Y registers need explicit
    * initialization. It will be cheaper to zero all Y registers.
    */
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      alloc->op = __make_opname__(allocate_heap_zero, 3);
      alloc->arity = 3;
#undef __make_opname__
    } while (0);
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      alloc->op = __make_opname__(allocate_heap, 3);
      alloc->arity = 3;
#undef __make_opname__
    } while (0);
    p = &alloc->next;
    do {
      int i;
      for (i = 0; i < N.val; i++) {
        BeamOp* init;

        init = beamopallocator_new_op(&(S)->op_allocator);
        init->next = NULL;;
        do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
          init->op = __make_opname__(init, 1);
          init->arity = 1;
#undef __make_opname__
        } while (0);
        init->a[0] = Yregs[i];
        *p = init;
        p = &init->next;
      }
    } while (0);
  }
  return alloc;;
}

static BeamOp* bs_restore(LoaderState* S, BeamOpArg Reg, BeamOpArg Index) {
  do {
    BeamOp* op;

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_restore2, 2);
      op->arity = 2;
#undef __make_opname__
    } while (0);
    op->a[0] = Reg;
    op->a[1] = Index;
    if (Index.type == TAG_u) {
      op->a[1].val = Index.val+1;
    } else if (Index.type == TAG_a && Index.val == am_start) {
      op->a[1].type = TAG_u;
      op->a[1].val = 0;
    }
    return op;
  } while (0);;
}

static BeamOp* bs_save(LoaderState* S, BeamOpArg Reg, BeamOpArg Index) {
  do {
    BeamOp* op;

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_save2, 2);
      op->arity = 2;
#undef __make_opname__
    } while (0);
    op->a[0] = Reg;
    op->a[1] = Index;
    if (Index.type == TAG_u) {
      op->a[1].val = Index.val+1;
    } else if (Index.type == TAG_a && Index.val == am_start) {
      op->a[1].type = TAG_u;
      op->a[1].val = 0;
    }
    return op;
  } while (0);;
}

static BeamOp* const_select_val(LoaderState* S, BeamOpArg Src, BeamOpArg Fail, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  int i;

  ASSERT(Size.type == TAG_u);

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(jump, 1);
    op->arity = 1;
#undef __make_opname__
  } while (0);
  op->next = NULL;

  /* Search for a literal matching the controlling expression. */
  switch (Src.type) {
    case TAG_q:
    {
      Eterm expr = beamfile_get_literal(&S->beam, Src.val);
      for (i = 0; i < Size.val; i += 2) {
        if (Rest[i].type == TAG_q) {
          Eterm term = beamfile_get_literal(&S->beam, Rest[i].val);
          if (eq(term, expr)) {
            ASSERT(Rest[i+1].type == TAG_f);
            op->a[0] = Rest[i+1];
            return op;
          }
        }
      }
    }
    break;
    case TAG_i:
    case TAG_a:
    for (i = 0; i < Size.val; i += 2) {
      if (Rest[i].val == Src.val && Rest[i].type == Src.type) {
        ASSERT(Rest[i+1].type == TAG_f);
        op->a[0] = Rest[i+1];
        return op;
      }
    }
    break;
  }

  /*
  * No match.  Use the failure label.
  */

  op->a[0] = Fail;
  return op;;
}

static BeamOp* element(LoaderState* S, BeamOpArg Fail, BeamOpArg Index, BeamOpArg Tuple, BeamOpArg Dst) {
  BeamOp* op;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  op->next = NULL;

  if (Index.type == TAG_i && Index.val > 0 &&
  Index.val <= ERTS_MAX_TUPLE_SIZE &&
  (Tuple.type == TAG_x || Tuple.type == TAG_y)) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_fast_element, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Tuple;
    op->a[1] = Fail;
    op->a[2].type = TAG_u;
    op->a[2].val = Index.val;
    op->a[3] = Dst;
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_element, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Tuple;
    op->a[1] = Fail;
    op->a[2] = Index;
    op->a[3] = Dst;
  }

  return op;;
}

static BeamOp* get(LoaderState* S, BeamOpArg Src, BeamOpArg Dst) {
  BeamOp* op;
  Eterm key_term;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  key_term = beam_load_get_term(S, Src);
  if (is_value(key_term)) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_get_hash, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Src;
    op->a[1].type = TAG_u;
    op->a[1].val = (BeamInstr) erts_pd_make_hx(key_term);
    op->a[2] = Dst;
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_get, 2);
      op->arity = 2;
#undef __make_opname__
    } while (0);
    op->a[0] = Src;
    op->a[1] = Dst;
  }
  return op;;
}

static BeamOp* get_binary2(LoaderState* S, BeamOpArg Fail, BeamOpArg Ms, BeamOpArg Live, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags, BeamOpArg Dst) {
  BeamOp* op;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);

  if (Size.type == TAG_a && Size.val == am_all) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_get_binary_all2, 5);
      op->arity = 5;
#undef __make_opname__
    } while (0);
    op->a[0] = Ms;
    op->a[1] = Fail;
    op->a[2] = Live;
    op->a[3] = Unit;
    op->a[4] = Dst;
  } else if (Size.type == TAG_i) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_get_binary_imm2, 6);
      op->arity = 6;
#undef __make_opname__
    } while (0);
    op->a[0] = Ms;
    op->a[1] = Fail;
    op->a[2] = Live;
    op->a[3].type = TAG_u;
    if (!beam_load_safe_mul(Size.val, Unit.val, &op->a[3].val)) {
      goto error;
    }
    op->a[4] = Flags;
    op->a[5] = Dst;
  } else if (Size.type == TAG_q) {
    Eterm big = beamfile_get_literal(&S->beam, Size.val);
    Uint bigval;

    if (!term_to_Uint(big, &bigval)) {
      error:
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(jump, 1);
        op->arity = 1;
#undef __make_opname__
      } while (0);
      op->a[0] = Fail;
    } else {
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_bs_get_binary_imm2, 6);
        op->arity = 6;
#undef __make_opname__
      } while (0);
      op->a[0] = Ms;
      op->a[1] = Fail;
      op->a[2] = Live;
      op->a[3].type = TAG_u;
      if (!beam_load_safe_mul(bigval, Unit.val, &op->a[3].val)) {
        goto error;
      }
      op->a[4] = Flags;
      op->a[5] = Dst;
    }
  } else if (Size.type == TAG_x || Size.type == TAG_y) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_get_binary2, 6);
      op->arity = 6;
#undef __make_opname__
    } while (0);
    op->a[0] = Ms;
    op->a[1] = Fail;
    op->a[2] = Live;
    op->a[3] = Size;
    op->a[4].type = TAG_u;
    op->a[4].val = (Unit.val << 3) | Flags.val;
    op->a[5] = Dst;
  } else {
    /* Invalid literal size. */
    goto error;
  }
  op->next = NULL;
  return op;;
}

static BeamOp* get_float2(LoaderState* S, BeamOpArg Fail, BeamOpArg Ms, BeamOpArg Live, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags, BeamOpArg Dst) {
  BeamOp* op;
  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_bs_get_float2, 6);
    op->arity = 6;
#undef __make_opname__
  } while (0);
  op->a[0] = Ms;
  op->a[1] = Fail;
  op->a[2] = Live;
  op->a[3] = Size;
  op->a[4].type = TAG_u;
  op->a[4].val = (Unit.val << 3) | Flags.val;
  op->a[5] = Dst;
  return op;;
}

static BeamOp* get_integer2(LoaderState* S, BeamOpArg Fail, BeamOpArg Ms, BeamOpArg Live, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags, BeamOpArg Dst) {
  BeamOp* op;
  UWord bits;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);
  if (Size.type == TAG_i) {
    if (!beam_load_safe_mul(Size.val, Unit.val, &bits)) {
      goto error;
    } else if ((Flags.val & BSF_SIGNED) != 0) {
      goto generic;
    } else if (bits == 8) {
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_bs_get_integer_8, 3);
        op->arity = 3;
#undef __make_opname__
      } while (0);
      op->a[0] = Ms;
      op->a[1] = Fail;
      op->a[2] = Dst;
    } else if (bits == 16 && (Flags.val & BSF_LITTLE) == 0) {
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_bs_get_integer_16, 3);
        op->arity = 3;
#undef __make_opname__
      } while (0);
      op->a[0] = Ms;
      op->a[1] = Fail;
      op->a[2] = Dst;
#ifdef ARCH_64
    } else if (bits == 32 && (Flags.val & BSF_LITTLE) == 0) {
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_bs_get_integer_32, 3);
        op->arity = 3;
#undef __make_opname__
      } while (0);
      op->a[0] = Ms;
      op->a[1] = Fail;
      op->a[2] = Dst;
#endif
    } else {
      generic:
      if (bits < SMALL_BITS) {
        do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
          op->op = __make_opname__(i_bs_get_integer_small_imm, 5);
          op->arity = 5;
#undef __make_opname__
        } while (0);
        op->a[0] = Ms;
        op->a[1].type = TAG_u;
        op->a[1].val = bits;
        op->a[2] = Fail;
        op->a[3] = Flags;
        op->a[4] = Dst;
      } else {
        do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
          op->op = __make_opname__(i_bs_get_integer_imm, 6);
          op->arity = 6;
#undef __make_opname__
        } while (0);
        op->a[0] = Ms;
        op->a[1].type = TAG_u;
        op->a[1].val = bits;
        op->a[2] = Live;
        op->a[3] = Fail;
        op->a[4] = Flags;
        op->a[5] = Dst;
      }
    }
  } else if (Size.type == TAG_q) {
    Eterm big = beamfile_get_literal(&S->beam, Size.val);
    Uint bigval;

    if (!term_to_Uint(big, &bigval)) {
      error:
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(jump, 1);
        op->arity = 1;
#undef __make_opname__
      } while (0);
      op->a[0] = Fail;
    } else {
      if (!beam_load_safe_mul(bigval, Unit.val, &bits)) {
        goto error;
      }
      goto generic;
    }
  } else if (Size.type == TAG_x || Size.type == TAG_y) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_get_integer, 6);
      op->arity = 6;
#undef __make_opname__
    } while (0);
    op->a[0] = Ms;
    op->a[1] = Fail;
    op->a[2] = Live;
    op->a[3].type = TAG_u;
    op->a[3].val = (Unit.val << 3) | Flags.val;
    op->a[4] = Size;
    op->a[5] = Dst;
    return op;
  } else {
    /* Invalid literal size. */
    goto error;
  }
  return op;;
}

static BeamOp* get_map_element(LoaderState* S, BeamOpArg Fail, BeamOpArg Src, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  BeamOpArg Key;
  Eterm key_term;

  ASSERT(Size.type == TAG_u);

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  op->a[0] = Fail;
  op->a[1] = Src;
  op->a[2] = Rest[0];

  Key = Rest[0];
  key_term = beam_load_get_term(S, Key);
  if (is_value(key_term)) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_get_map_element_hash, 5);
      op->arity = 5;
#undef __make_opname__
    } while (0);
    op->a[3].type = TAG_u;
    op->a[3].val = (BeamInstr) hashmap_make_hash(key_term);
    op->a[4] = Rest[1];
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_get_map_element, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[3] = Rest[1];
  }
  return op;;
}

static BeamOp* get_map_elements(LoaderState* S, BeamOpArg Fail, BeamOpArg Src, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  Uint i;
  BeamOpArg* dst;
  Eterm key_term;

  ASSERT(Size.type == TAG_u);

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_get_map_elements, 3);
    op->arity = 3;
#undef __make_opname__
  } while (0);
  ASSERT(op->a == op->def_args);

  op->arity = 3 + 3*(Size.val/2);
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->a[0] = Fail;
  op->a[1] = Src;
  op->a[2].type = TAG_u;
  op->a[2].val = 3*(Size.val/2);

  dst = op->a+3;
  for (i = 0; i < Size.val / 2; i++) {
    dst[0] = Rest[2*i];
    dst[1] = Rest[2*i+1];
    dst[2].type = TAG_u;
    key_term = beam_load_get_term(S, dst[0]);
    dst[2].val = (BeamInstr) hashmap_make_hash(key_term);
    dst += 3;
  }
  return op;;
}

static BeamOp* has_map_fields(LoaderState* S, BeamOpArg Fail, BeamOpArg Src, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  Uint i;
  Uint n;

  ASSERT(Size.type == TAG_u);
  n = Size.val;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(get_map_elements, 3);
    op->arity = 3;
#undef __make_opname__
  } while (0);
  ASSERT(op->a == op->def_args);

  op->arity = 3 + 2*n;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;

  op->a[0] = Fail;
  op->a[1] = Src;
  op->a[2].type = TAG_u;
  op->a[2].val = 2*n;

  for (i = 0; i < n; i++) {
    op->a[3+2*i] = Rest[i];
    op->a[3+2*i+1].type = TAG_x;
    op->a[3+2*i+1].val = SCRATCH_X_REG; /* Ignore result */
  }
  return op;;
}

static BeamOp* increment(LoaderState* S, BeamOpArg Reg, BeamOpArg Integer, BeamOpArg Dst) {
  do {
    BeamOp* op;
    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_increment, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Reg;
    op->a[1].type = TAG_u;
    op->a[1].val = Integer.val;
    op->a[2] = Dst;
    return op;
  } while (0);;
}

static BeamOp* increment_from_minus(LoaderState* S, BeamOpArg Reg, BeamOpArg Integer, BeamOpArg Dst) {
  do {
    BeamOp* op;
    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_increment, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Reg;
    op->a[1].type = TAG_u;
    op->a[1].val = -Integer.val;
    op->a[2] = Dst;
    return op;
  } while (0);;
}

static BeamOp* init_yregs(LoaderState* S, BeamOpArg N, BeamOpArg* Yregs) {
  BeamOp* first = NULL;
  BeamOp** p;

  p = &first;
  do {
    int i;
    for (i = 0; i < N.val; i++) {
      BeamOp* init;

      init = beamopallocator_new_op(&(S)->op_allocator);
      init->next = NULL;;
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        init->op = __make_opname__(init, 1);
        init->arity = 1;
#undef __make_opname__
      } while (0);
      init->a[0] = Yregs[i];
      *p = init;
      p = &init->next;
    }
  } while (0);
  return first;;
}

static BeamOp* is_function2(LoaderState* S, BeamOpArg Fail, BeamOpArg Fun, BeamOpArg Arity) {
  BeamOp* op;
  int literal_arity = Arity.type == TAG_i;
  int fun_is_reg = Fun.type == TAG_x || Fun.type == TAG_y;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  if (fun_is_reg && literal_arity) {
    /*
    * Most common case. Fun in a register and arity
    * is an integer literal.
    */
    if (Arity.val > MAX_ARG) {
      /* Arity is negative or too big. */
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(jump, 1);
        op->arity = 1;
#undef __make_opname__
      } while (0);
      op->a[0] = Fail;
      return op;
    } else {
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(hot_is_function2, 3);
        op->arity = 3;
#undef __make_opname__
      } while (0);
      op->a[0] = Fail;
      op->a[1] = Fun;
      op->a[2].type = TAG_u;
      op->a[2].val = Arity.val;
      return op;
    }
  } else {
    /*
    * Handle extremely uncommon cases by a slower sequence.
    */
    BeamOp* move_fun;
    BeamOp* move_arity;

    move_fun = beamopallocator_new_op(&(S)->op_allocator);
    move_fun->next = NULL;;
    move_arity = beamopallocator_new_op(&(S)->op_allocator);
    move_arity->next = NULL;;

    move_fun->next = move_arity;
    move_arity->next = op;

    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      move_fun->op = __make_opname__(move, 2);
      move_fun->arity = 2;
#undef __make_opname__
    } while (0);
    move_fun->a[0] = Fun;
    move_fun->a[1].type = TAG_x;
    move_fun->a[1].val = 1022;

    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      move_arity->op = __make_opname__(move, 2);
      move_arity->arity = 2;
#undef __make_opname__
    } while (0);
    move_arity->a[0] = Arity;
    move_arity->a[1].type = TAG_x;
    move_arity->a[1].val = 1023;

    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(cold_is_function2, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1].type = TAG_x;
    op->a[1].val = 1022;
    op->a[2].type = TAG_x;
    op->a[2].val = 1023;
    return move_fun;
  };
}

static BeamOp* jump_tab(LoaderState* S, BeamOpArg Src, BeamOpArg Fail, BeamOpArg Size, BeamOpArg* Rest) {
  Sint min, max;
  Sint i;
  Sint size;
  Sint arity;
  int fixed_args;
  BeamOp* op;

  ASSERT(Size.val >= 2 && Size.val % 2 == 0);

  /* Don't generate a jump table if there's only one choice */
  if (Size.val == 2) {
    BeamOp* jump;

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(is_ne_exact, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Rest[1];
    op->a[1] = Src;
    op->a[2] = Rest[0];

    jump = beamopallocator_new_op(&(S)->op_allocator);
    jump->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      jump->op = __make_opname__(jump, 1);
      jump->arity = 1;
#undef __make_opname__
    } while (0);
    jump->a[0] = Fail;

    op->next = jump;
    jump->next = NULL;
    return op;
  }

  /* Calculate the minimum and maximum values and size of jump table. */
  ASSERT(Rest[0].type == TAG_i);
  min = max = Rest[0].val;
  for (i = 2; i < Size.val; i += 2) {
    ASSERT(Rest[i].type == TAG_i && Rest[i+1].type == TAG_f);
    if (Rest[i].val < min) {
      min = Rest[i].val;
    } else if (max < Rest[i].val) {
      max = Rest[i].val;
    }
  }
  size = max - min + 1;

  /* Allocate structure and fill in the fixed fields. */
  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  op->next = NULL;
  if (min == 0) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_jump_on_val_zero, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_jump_on_val, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
  }
  fixed_args = op->arity;
  arity = fixed_args + size;
  ASSERT(op->a == op->def_args);

  op->arity = arity;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->a[0] = Src;
  op->a[1] = Fail;
  op->a[2].type = TAG_u;
  op->a[2].val = size;
  op->a[3].type = TAG_u;
  op->a[3].val = min;

  /* Fill in the jump table. */
  for (i = fixed_args; i < arity; i++) {
    op->a[i] = Fail;
  }

  for (i = 0; i < Size.val; i += 2) {
    Sint index = fixed_args + Rest[i].val - min;
    ASSERT(fixed_args <= index && index < arity);
    op->a[index] = Rest[i+1];
  }

  return op;;
}

static BeamOp* literal_timeout(LoaderState* S, BeamOpArg Fail, BeamOpArg Time) {
  do {
    BeamOp* op;
    Sint timeout;

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(wait_timeout_unlocked_int, 2);
      op->arity = 2;
#undef __make_opname__
    } while (0);
    op->a[0].type = TAG_u;
    op->a[1] = Fail;

    if (Time.type == TAG_i && (timeout = Time.val) >= 0 &&
#if defined(ARCH_64)
    (timeout >> 32) == 0
#else
    1
#endif
    ) {
      op->a[0].val = timeout;
#if !defined(ARCH_64)
    } else if (Time.type == TAG_q) {
      Eterm big = beamfile_get_literal(&S->beam, Time.val);

      if (is_not_big(big)) {
        goto error;
      }

      if (big_arity(big) > 1 || big_sign(big)) {
        goto error;
      } else {
        Uint u;
        (void) term_to_Uint(big, &u);
        op->a[0].val = (BeamInstr) u;
      }
#endif
    } else {
#if !defined(ARCH_64)
      error:
#endif
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_wait_error, 0);
        op->arity = 0;
#undef __make_opname__
      } while (0);
    }
    return op;
  } while (0);;
}

static BeamOp* literal_timeout_locked(LoaderState* S, BeamOpArg Fail, BeamOpArg Time) {
  do {
    BeamOp* op;
    Sint timeout;

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(wait_timeout_locked_int, 2);
      op->arity = 2;
#undef __make_opname__
    } while (0);
    op->a[0].type = TAG_u;
    op->a[1] = Fail;

    if (Time.type == TAG_i && (timeout = Time.val) >= 0 &&
#if defined(ARCH_64)
    (timeout >> 32) == 0
#else
    1
#endif
    ) {
      op->a[0].val = timeout;
#if !defined(ARCH_64)
    } else if (Time.type == TAG_q) {
      Eterm big = beamfile_get_literal(&S->beam, Time.val);

      if (is_not_big(big)) {
        goto error;
      }

      if (big_arity(big) > 1 || big_sign(big)) {
        goto error;
      } else {
        Uint u;
        (void) term_to_Uint(big, &u);
        op->a[0].val = (BeamInstr) u;
      }
#endif
    } else {
#if !defined(ARCH_64)
      error:
#endif
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_wait_error_locked, 0);
        op->arity = 0;
#undef __make_opname__
      } while (0);
    }
    return op;
  } while (0);;
}

static BeamOp* make_fun2(LoaderState* S, BeamOpArg idx) {
  BeamOp* op;
  BeamOp* th;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  if (idx.val >= S->beam.lambdas.count) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_lambda_error, 1);
      op->arity = 1;
#undef __make_opname__
    } while (0);
    op->a[0].type = TAG_o;
    op->a[0].val = 0;
    return op;
  } else {
    int i;
    BeamFile_LambdaEntry *entry = &S->beam.lambdas.entries[idx.val];
    unsigned num_free = entry->num_free;

    th = beamopallocator_new_op(&(S)->op_allocator);
    th->next = NULL;;

    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      th->op = __make_opname__(test_heap, 2);
      th->arity = 2;
#undef __make_opname__
    } while (0);
    th->a[0].type = TAG_u;
    th->a[0].val = ERL_FUN_SIZE + num_free;
    th->a[1].type = TAG_u;
    th->a[1].val = num_free;
    th->next = op;

    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_make_fun3, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    ASSERT(op->a == op->def_args);

    op->arity = 3 + num_free;
    op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
    op->a[0].type = TAG_u;
    op->a[0].val = idx.val;
    op->a[1].type = TAG_x;
    op->a[1].val = 0;
    op->a[2].type = TAG_u;
    op->a[2].val = num_free;
    for (i = 0; i < num_free; i++) {
      op->a[i+3].type = TAG_x;
      op->a[i+3].val = i;
    }
    return th;
  };
}

static BeamOp* make_fun3(LoaderState* S, BeamOpArg idx, BeamOpArg Dst, BeamOpArg NumFree, BeamOpArg* Env) {
  BeamOp* op;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  if (idx.val < S->beam.lambdas.count) {
    BeamFile_LambdaEntry *entry = &S->beam.lambdas.entries[idx.val];
    if (NumFree.val == entry->num_free) {
      int i;

      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_make_fun3, 3);
        op->arity = 3;
#undef __make_opname__
      } while (0);
      ASSERT(op->a == op->def_args);

      op->arity = 3 + NumFree.val;
      op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
      op->a[0].type = TAG_u;
      op->a[0].val = idx.val;
      op->a[1] = Dst;
      op->a[2].type = TAG_u;
      op->a[2].val = entry->num_free;
      for (i = 0; i < NumFree.val; i++) {
        op->a[i+3] = Env[i];
      }
      return op;
    }
  }
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_lambda_error, 1);
    op->arity = 1;
#undef __make_opname__
  } while (0);
  op->a[0].type = TAG_o;
  op->a[0].val = 0;
  return op;;
}

static BeamOp* new_small_map_lit(LoaderState* S, BeamOpArg Dst, BeamOpArg Live, BeamOpArg Size, BeamOpArg* Rest) {
  unsigned size = Size.val;
  Uint lit;
  unsigned i;
  BeamOp* op;
  BeamOpArg* dst;
  Eterm* tmp;
  Eterm* thp;
  Eterm keys;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_new_small_map_lit, 3);
    op->arity = 3;
#undef __make_opname__
  } while (0);
  ASSERT(op->a == op->def_args);

  op->arity = 3 + size/2;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->next = NULL;

  tmp = thp = erts_alloc(ERTS_ALC_T_LOADER_TMP, (1 + size/2) * sizeof(*tmp));
  keys = make_tuple(thp);
  *thp++ = make_arityval(size/2);

  dst = op->a+3;

  for (i = 0; i < size; i += 2) {
    switch (Rest[i].type) {
      case TAG_a:
      *thp++ = Rest[i].val;
      ASSERT(is_atom(Rest[i].val));
      break;
      case TAG_i:
      *thp++ = make_small(Rest[i].val);
      break;
      case TAG_n:
      *thp++ = NIL;
      break;
      case TAG_q:
      *thp++ = beamfile_get_literal(&S->beam, Rest[i].val);
      break;
    }
    *dst++ = Rest[i + 1];
  }

  lit = beamfile_add_literal(&S->beam, keys);
  erts_free(ERTS_ALC_T_LOADER_TMP, tmp);

  op->a[0] = Dst;
  op->a[1] = Live;
  op->a[2].type = TAG_q;
  op->a[2].val = lit;

  return op;;
}

static BeamOp* plus_from_minus(LoaderState* S, BeamOpArg Fail, BeamOpArg Live, BeamOpArg Src, BeamOpArg Integer, BeamOpArg Dst) {
  BeamOp* op;

  ASSERT(Integer.type == TAG_i && IS_SSMALL(-(Sint)Integer.val));

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(gen_plus, 5);
    op->arity = 5;
#undef __make_opname__
  } while (0);
  op->a[0] = Fail;
  op->a[1] = Live;
  op->a[2] = Src;
  op->a[3].type = TAG_i;
  op->a[3].val = -(Sint)Integer.val;
  op->a[4] = Dst;

  return op;;
}

static BeamOp* put_binary(LoaderState* S, BeamOpArg Fail, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags, BeamOpArg Src) {
  BeamOp* op;
  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);
  if (Size.type == TAG_a && Size.val == am_all) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_binary_all, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Src;
    op->a[1] = Fail;
    op->a[2] = Unit;
  } else if (Size.type == TAG_i) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_binary_imm, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1].type = TAG_u;
    if (beam_load_safe_mul(Size.val, Unit.val, &op->a[1].val)) {
      op->a[2] = Src;
    } else {
      error:
      /*
      * Invalid size. This instruction can't possibly be
      * reached, because bs_add or bs_init* would already
      * have raised a system_limit exception.
      */
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(delete_me, 0);
        op->arity = 0;
#undef __make_opname__
      } while (0);
    }
  } else if (Size.type == TAG_q) {
#ifdef ARCH_64
    /*
    * There is no way that this binary would fit in memory.
    */
    goto error;
#else
    Eterm big = beamfile_get_literal(&S->beam, Size.val);
    Uint bigval;
    Uint size;

    if (!term_to_Uint(big, &bigval) ||
    !beam_load_safe_mul(bigval, Unit.val, &size)) {
      goto error;
    }
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_binary_imm, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1].type = TAG_u;
    op->a[1].val = size;
    op->a[2] = Src;
#endif
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_binary, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1] = Size;
    op->a[2].type = TAG_u;
    op->a[2].val = (Unit.val << 3) | (Flags.val & 7);
    op->a[3] = Src;
  }

  return op;;
}

static BeamOp* put_float(LoaderState* S, BeamOpArg Fail, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags, BeamOpArg Src) {
  BeamOp* op;
  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);
  if (Size.type == TAG_i) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_float_imm, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1].type = TAG_u;
    if (!beam_load_safe_mul(Size.val, Unit.val, &op->a[1].val)) {
      /*
      * Size overflow. This instruction can't possibly be reached, because
      * bs_add or bs_init* would already have raised a system_limit
      * exception.
      */
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(delete_me, 0);
        op->arity = 0;
#undef __make_opname__
      } while (0);
    } else {
      op->a[2] = Flags;
      op->a[3] = Src;
    }
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_float, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1] = Size;
    op->a[2].type = TAG_u;
    op->a[2].val = (Unit.val << 3) | (Flags.val & 7);
    op->a[3] = Src;
  }
  return op;;
}

static BeamOp* put_integer(LoaderState* S, BeamOpArg Fail, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags, BeamOpArg Src) {
  BeamOp* op;
  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);
  /* Negative size must fail */
  if (Size.type == TAG_i) {
    Uint size;
    if (!beam_load_safe_mul(Size.val, Unit.val, &size)) {
      error:
      /*
      * Invalid size. This instruction can't possibly be
      * reached, because bs_add or bs_init* would already
      * have raised a system_limit exception.
      */
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(delete_me, 0);
        op->arity = 0;
#undef __make_opname__
      } while (0);
      return op;
    }
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_integer_imm, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Src;
    op->a[1] = Fail;
    op->a[2].type = TAG_u;
    op->a[2].val = size;
    op->a[3].type = Flags.type;
    op->a[3].val = (Flags.val & 7);
  } else if (Size.type == TAG_q) {
    Eterm big = beamfile_get_literal(&S->beam, Size.val);
    Uint bigval;
    Uint size;

    if (!term_to_Uint(big, &bigval) ||
    !beam_load_safe_mul(bigval, Unit.val, &size)) {
      goto error;
    }
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_integer_imm, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Src;
    op->a[1] = Fail;
    op->a[2].type = TAG_u;
    op->a[2].val = size;
    op->a[3].type = Flags.type;
    op->a[3].val = (Flags.val & 7);
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_new_bs_put_integer, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1] = Size;
    op->a[2].type = TAG_u;
    op->a[2].val = (Unit.val << 3) | (Flags.val & 7);
    op->a[3] = Src;
  }
  return op;;
}

static BeamOp* select_literals(LoaderState* S, BeamOpArg Src, BeamOpArg Fail, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  BeamOp* jump;
  BeamOp** prev_next = &op;

  int i;

  for (i = 0; i < Size.val; i += 2) {
    BeamOp* op;
    ASSERT(Rest[i].type == TAG_q);

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(is_ne_exact, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Rest[i+1];
    op->a[1] = Src;
    op->a[2] = Rest[i];
    *prev_next = op;
    prev_next = &op->next;
  }

  jump = beamopallocator_new_op(&(S)->op_allocator);
  jump->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    jump->op = __make_opname__(jump, 1);
    jump->arity = 1;
#undef __make_opname__
  } while (0);
  jump->next = NULL;
  jump->a[0] = Fail;
  *prev_next = jump;
  return op;;
}

static BeamOp* select_tuple_arity(LoaderState* S, BeamOpArg Src, BeamOpArg Fail, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  BeamOpArg *tmp;
  int arity = Size.val + 3;
  int size = Size.val / 2;
  int i, j, align = 0;

  /* Verify the validity of the list. */

  if (Size.val % 2 != 0) {
    return NULL;
  }

  for (i = 0; i < Size.val; i += 2) {
    if (Rest[i].type != TAG_u || Rest[i+1].type != TAG_f) {
      return NULL;
    }
  }

  /*
  * Use a special-cased instruction if there are only two values.
  */
  if (size == 2) {
    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_select_tuple_arity2, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    ASSERT(op->a == op->def_args);

    op->arity = arity - 1;
    op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
    op->next = NULL;
    op->a[0] = Src;
    op->a[1] = Fail;
    op->a[2].type = TAG_u;
    op->a[2].val  = Rest[0].val;
    op->a[3].type = TAG_u;
    op->a[3].val  = Rest[2].val;
    op->a[4] = Rest[1];
    op->a[5] = Rest[3];

    return op;
  }

  /*
  * Generate the generic instruction.
  * Assumption:
  *   Few different tuple arities to select on (fewer than 20).
  *   Use linear scan approach.
  */

  align = 1;

  arity += 2*align;
  size  += align;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_select_tuple_arity, 3);
    op->arity = 3;
#undef __make_opname__
  } while (0);
  ASSERT(op->a == op->def_args);

  op->arity = arity;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->next = NULL;
  op->a[0] = Src;
  op->a[1] = Fail;
  op->a[2].type = TAG_u;
  op->a[2].val = size;

  tmp = (BeamOpArg *) erts_alloc(ERTS_ALC_T_LOADER_TMP, sizeof(BeamOpArg)*(arity-2*align));

  for (i = 3; i < arity - 2*align; i+=2) {
    tmp[i-3].type = TAG_v;
    tmp[i-3].val  = make_arityval(Rest[i-3].val);
    tmp[i-2]      = Rest[i-2];
  }

  /* Sort the values to make them useful for a binary or sentinel search. */
  beam_load_sort_select_vals(tmp, size - align);

  j = 3;
  for (i = 3; i < arity - 2*align; i += 2) {
    op->a[j]        = tmp[i-3];
    op->a[j + size] = tmp[i-2];
    j++;
  }

  erts_free(ERTS_ALC_T_LOADER_TMP, (void *) tmp);

  op->a[j].type = TAG_u;
  op->a[j].val  = ~((BeamInstr)0);
  op->a[j+size] = Fail;

  return op;;
}

static BeamOp* select_val(LoaderState* S, BeamOpArg Src, BeamOpArg Fail, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op;
  BeamOpArg *tmp;
  int arity = Size.val + 3;
  int size = Size.val / 2;
  int i, j, align = 0;

  if (size == 2) {
    /*
    * Use a special-cased instruction if there are only two values.
    */

    op = beamopallocator_new_op(&(S)->op_allocator);
    op->next = NULL;;
    op->next = NULL;
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_select_val2, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    ASSERT(op->a == op->def_args);

    op->arity = arity - 1;
    op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
    op->a[0] = Src;
    op->a[1] = Fail;
    op->a[2] = Rest[0];
    op->a[3] = Rest[2];
    op->a[4] = Rest[1];
    op->a[5] = Rest[3];

    return op;
  }

  if (size <= 10) {
    /* Use linear search. Reserve place for a sentinel. */
    align = 1;
  }

  arity += 2*align;
  size  += align;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  op->next = NULL;
  if (align == 0) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_select_val_bins, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
  } else {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_select_val_lins, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
  }
  ASSERT(op->a == op->def_args);

  op->arity = arity;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->a[0] = Src;
  op->a[1] = Fail;
  op->a[2].type = TAG_u;
  op->a[2].val = size;

  tmp = (BeamOpArg *) erts_alloc(ERTS_ALC_T_LOADER_TMP, sizeof(BeamOpArg)*(arity-2*align));

  for (i = 3; i < arity - 2*align; i++) {
    tmp[i-3] = Rest[i-3];
  }

  /* Sort the values to make them useful for a binary or sentinel search. */
  beam_load_sort_select_vals(tmp, size - align);

  j = 3;
  for (i = 3; i < arity - 2*align; i += 2) {
    op->a[j]      = tmp[i-3];
    op->a[j+size] = tmp[i-2];
    j++;
  }

  erts_free(ERTS_ALC_T_LOADER_TMP, (void *) tmp);

  if (align) {
    /* Add sentinel for linear search. */
    op->a[j].type = TAG_u;
    op->a[j].val  = ~((BeamInstr)0);
    op->a[j+size] = Fail;
  }

#ifdef DEBUG
  for (i = 0; i < size - 1; i++) {
    ASSERT(op->a[i+3].val <= op->a[i+4].val);
  }
#endif

  return op;;
}

static BeamOp* skip_bits2(LoaderState* S, BeamOpArg Fail, BeamOpArg Ms, BeamOpArg Size, BeamOpArg Unit, BeamOpArg Flags) {
  BeamOp* op;
  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;

  do {
#if defined(WORDS_BIGENDIAN)
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~(BSF_LITTLE|BSF_NATIVE);
    }
#else
    if ((Flags).val & BSF_NATIVE) {
      (Flags).val &= ~BSF_NATIVE;
      (Flags).val |= BSF_LITTLE;
    }
#endif
  } while (0);
  if (Size.type == TAG_a && Size.val == am_all) {
    /*
    * This kind of skip instruction will only be found in modules
    * compiled before OTP 19. From OTP 19, the compiler generates
    * a test_unit instruction of a bs_skip at the end of a
    * binary.
    *
    * It is safe to replace the skip instruction with a test_unit
    * instruction, because the position will never be used again.
    * If the match context itself is used again, it will be used by
    * a bs_restore2 instruction which will overwrite the position
    * by one of the stored positions.
    */
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(bs_test_unit, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1] = Ms;
    op->a[2] = Unit;
  } else if (Size.type == TAG_i) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_skip_bits_imm2, 3);
      op->arity = 3;
#undef __make_opname__
    } while (0);
    op->a[0] = Fail;
    op->a[1] = Ms;
    op->a[2].type = TAG_u;
    if (!beam_load_safe_mul(Size.val, Unit.val, &op->a[2].val)) {
      goto error;
    }
  } else if (Size.type == TAG_q) {
    Eterm big = beamfile_get_literal(&S->beam, Size.val);
    Uint bigval;

    if (!term_to_Uint(big, &bigval)) {
      error:
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(jump, 1);
        op->arity = 1;
#undef __make_opname__
      } while (0);
      op->a[0] = Fail;
    } else {
      do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
        op->op = __make_opname__(i_bs_skip_bits_imm2, 3);
        op->arity = 3;
#undef __make_opname__
      } while (0);
      op->a[0] = Fail;
      op->a[1] = Ms;
      op->a[2].type = TAG_u;
      if (!beam_load_safe_mul(bigval, Unit.val, &op->a[2].val)) {
        goto error;
      }
    }
  } else if (Size.type == TAG_x || Size.type == TAG_y) {
    do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
      op->op = __make_opname__(i_bs_skip_bits2, 4);
      op->arity = 4;
#undef __make_opname__
    } while (0);
    op->a[0] = Ms;
    op->a[1] = Size;
    op->a[2] = Fail;
    op->a[3] = Unit;
  } else {
    /*
    * Invalid literal size. Can only happen if compiler
    * optimizations are selectively disabled.  For example,
    * at the time of writing, [no_copt, no_type_opt] will allow
    * skip instructions with invalid sizes to slip through.
    */
    goto error;
  }
  return op;;
}

static BeamOp* split_values(LoaderState* S, BeamOpArg Src, BeamOpArg TypeFail, BeamOpArg Fail, BeamOpArg Size, BeamOpArg* Rest) {
  BeamOp* op1;
  BeamOp* op2;
  BeamOp* label;
  BeamOp* is_integer;
  int i;

  ASSERT(Size.val >= 2 && Size.val % 2 == 0);

  is_integer = beamopallocator_new_op(&(S)->op_allocator);
  is_integer->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    is_integer->op = __make_opname__(is_integer, 2);
    is_integer->arity = 2;
#undef __make_opname__
  } while (0);
  is_integer->a[0] = TypeFail;
  is_integer->a[1] = Src;

  label = beamopallocator_new_op(&(S)->op_allocator);
  label->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    label->op = __make_opname__(label, 1);
    label->arity = 1;
#undef __make_opname__
  } while (0);
  label->a[0].type = TAG_u;
  label->a[0].val = beam_load_new_label(S);

  do {
    op1 = beamopallocator_new_op(&(S)->op_allocator);
    op1->next = NULL;
  } while (0);
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op1->op = __make_opname__(select_val, 3);
    op1->arity = 3;
#undef __make_opname__
  } while (0);
  ASSERT(op1->a == op1->def_args);

  op1->arity = 3 + Size.val;
  op1->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op1->arity * sizeof(BeamOpArg));;
  op1->a[0] = Src;
  op1->a[1].type = TAG_f;
  op1->a[1].val = label->a[0].val;
  op1->a[2].type = TAG_u;
  op1->a[2].val = 0;

  do {
    op2 = beamopallocator_new_op(&(S)->op_allocator);
    op2->next = NULL;
  } while (0);
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op2->op = __make_opname__(select_val, 3);
    op2->arity = 3;
#undef __make_opname__
  } while (0);
  ASSERT(op2->a == op2->def_args);

  op2->arity = 3 + Size.val;
  op2->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op2->arity * sizeof(BeamOpArg));;
  op2->a[0] = Src;
  op2->a[1] = Fail;
  op2->a[2].type = TAG_u;
  op2->a[2].val = 0;

  /* Split the list. */
  ASSERT(Size.type == TAG_u);
  for (i = 0; i < Size.val; i += 2) {
    BeamOp* op = (Rest[i].type == TAG_q) ? op2 : op1;
    int dst = 3 + op->a[2].val;

    ASSERT(Rest[i+1].type == TAG_f);
    op->a[dst] = Rest[i];
    op->a[dst+1] = Rest[i+1];
    op->arity += 2;
    op->a[2].val += 2;
  }
  ASSERT(op1->a[2].val > 0);
  ASSERT(op2->a[2].val > 0);

  /* Order the instruction sequence appropriately. */
  if (TypeFail.val == Fail.val) {
    /*
    * select_val L1 S ... (small numbers)
    * label L1
    * is_integer Fail S
    * select_val Fail S ... (bignums)
    */
    op1->next = label;
    label->next = is_integer;
    is_integer->next = op2;
  } else {
    /*
    * is_integer TypeFail S
    * select_val L1 S ... (small numbers)
    * label L1
    * select_val Fail S ... (bignums)
    */
    is_integer->next = op1;
    op1->next = label;
    label->next = op2;
    op1 = is_integer;
  }
  op2->next = NULL;

  return op1;;
}

static BeamOp* tuple_append_put(LoaderState* S, BeamOpArg Arity, BeamOpArg Dst, BeamOpArg* Puts, BeamOpArg Src) {
  BeamOp* op;
  int arity = Arity.val;      /* Arity of tuple, not the instruction */
  int i;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_put_tuple, 2);
    op->arity = 2;
#undef __make_opname__
  } while (0);
  ASSERT(op->a == op->def_args);

  op->arity = arity+2+1;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->a[0] = Dst;
  op->a[1].type = TAG_u;
  op->a[1].val = arity + 1;
  for (i = 0; i < arity; i++) {
    op->a[i+2] = Puts[i];
  }
  op->a[arity+2] = Src;
  return op;;
}

static BeamOp* tuple_append_put5(LoaderState* S, BeamOpArg Arity, BeamOpArg Dst, BeamOpArg* Puts, BeamOpArg S1, BeamOpArg S2, BeamOpArg S3, BeamOpArg S4, BeamOpArg S5) {
  BeamOp* op;
  int arity = Arity.val;      /* Arity of tuple, not the instruction */
  int i;

  op = beamopallocator_new_op(&(S)->op_allocator);
  op->next = NULL;;
  do {
#define __make_opname__(NAME, ARITY) genop_##NAME##_##ARITY
    op->op = __make_opname__(i_put_tuple, 2);
    op->arity = 2;
#undef __make_opname__
  } while (0);
  ASSERT(op->a == op->def_args);

  op->arity = arity+2+5;
  op->a = erts_alloc(ERTS_ALC_T_LOADER_TMP, op->arity * sizeof(BeamOpArg));;
  op->a[0] = Dst;
  op->a[1].type = TAG_u;
  op->a[1].val = arity + 5;
  for (i = 0; i < arity; i++) {
    op->a[i+2] = Puts[i];
  }
  op->a[arity+2] = S1;
  op->a[arity+3] = S2;
  op->a[arity+4] = S3;
  op->a[arity+5] = S4;
  op->a[arity+6] = S5;
  return op;;
}

BeamOp* erts_beam_execute_transform(unsigned int op, LoaderState* st, BeamOpArg var[], BeamOpArg* rest_args) {
  switch (op) {
    case 0: return allocate(st, var[0], var[1], var[2], rest_args);
    case 1: return allocate_heap(st, var[0], var[1], var[2], var[3], rest_args);
    case 2: return init_yregs(st, var[0], rest_args);
    case 3: return const_select_val(st, var[0], var[1], var[2], rest_args);
    case 4: return jump_tab(st, var[0], var[1], var[2], rest_args);
    case 5: return jump_tab(st, var[1], var[0], var[2], rest_args);
    case 6: return split_values(st, var[1], var[0], var[2], var[3], rest_args);
    case 7: return split_values(st, var[0], var[1], var[1], var[2], rest_args);
    case 8: return select_val(st, var[1], var[0], var[2], rest_args);
    case 9: return select_literals(st, var[0], var[1], var[2], rest_args);
    case 10: return select_val(st, var[0], var[1], var[2], rest_args);
    case 11: return select_tuple_arity(st, var[1], var[0], var[2], rest_args);
    case 12: return select_tuple_arity(st, var[0], var[1], var[2], rest_args);
    case 13: return literal_timeout(st, var[1], var[0]);
    case 14: return literal_timeout_locked(st, var[1], var[0]);
    case 15: return tuple_append_put5(st, var[1], var[0], rest_args, var[2], var[3], var[4], var[5], var[6]);
    case 16: return tuple_append_put(st, var[1], var[0], rest_args, var[2]);
    case 17: return is_function2(st, var[0], var[1], var[2]);
    case 18: return get(st, var[2], var[3]);
    case 19: return element(st, var[0], var[1], var[2], var[3]);
    case 20: return make_fun2(st, var[0]);
    case 21: return make_fun3(st, var[0], var[1], var[2], rest_args);
    case 22: return bs_save(st, var[0], var[1]);
    case 23: return bs_restore(st, var[0], var[1]);
    case 24: return get_integer2(st, var[0], var[1], var[2], var[3], var[4], var[5], var[6]);
    case 25: return get_binary2(st, var[0], var[1], var[2], var[3], var[4], var[5], var[6]);
    case 26: return get_float2(st, var[0], var[1], var[2], var[3], var[4], var[5], var[6]);
    case 27: return skip_bits2(st, var[0], var[1], var[2], var[3], var[4]);
    case 28: return put_integer(st, var[0], var[1], var[2], var[3], var[4]);
    case 29: return put_float(st, var[0], var[1], var[2], var[3], var[4]);
    case 30: return put_binary(st, var[0], var[1], var[2], var[3], var[4]);
    case 31: return new_small_map_lit(st, var[0], var[1], var[2], rest_args);
    case 32: return has_map_fields(st, var[0], var[1], var[2], rest_args);
    case 33: return get_map_element(st, var[0], var[1], var[2], rest_args);
    case 34: return get_map_elements(st, var[0], var[1], var[2], rest_args);
    case 35: return increment(st, var[2], var[1], var[3]);
    case 36: return increment(st, var[1], var[2], var[3]);
    case 37: return increment_from_minus(st, var[1], var[2], var[3]);
    case 38: return plus_from_minus(st, var[0], var[1], var[2], var[3], var[4]);
    default: erts_exit(ERTS_ABORT_EXIT, "erts_beam_execute_transform: invalid op %d\n", op);  }
}

